readline: fix script for finding libreadline

31 Jul 2015 16:43 - John Abbott

Status: Closed Start date: 31 Jul 2015

Priority: Immediate Due date:  

Assignee: John Abbott % Done: 100%

Category: External  Libs Estimated time: 4.01 hours

Target version: CoCoA-5.2.0 spring 2017 Spent time: 3.60 hours

Description

The script for finding libreadline (and lines in configure) are broken.  Fix them!

Related issues:

Related to CoCoALib - Design #933: Separate configure scripts for CoCoALib an... In Progress 30 Sep 2016

History

#1 - 31 Jul 2015 16:45 - John Abbott

Default should be to look for readline automatically?

Anyway make it work properly, like the other extlibs!

#2 - 17 Feb 2016 11:31 - John Abbott

My first hasty attempt to deal with libreadline was to treat it like the other external libraries; now I have some doubts because readline is needed only

by CoCoA-5, not by any part of CoCoALib, so it should not really be mixed up with the CoCoALib files....

What do you think?

#3 - 17 Feb 2016 11:32 - John Abbott

- Target version changed from CoCoA-5.1.3/4 Jan 2016 to CoCoA-5.2.0 spring 2017

#4 - 17 Feb 2016 11:39 - Anna Maria Bigatti

John Abbott wrote:

My first hasty attempt to deal with libreadline was to treat it like the other external libraries; now I have some doubts because readline is needed

only by CoCoA-5, not by any part of CoCoALib, so it should not really be mixed up with the CoCoALib files....

What do you think?

 

true... but it might be easier to deal with it together with the other libraries...

#5 - 13 Jun 2016 19:25 - John Abbott

- Status changed from New to Resolved
- % Done changed from 0 to 50

I have hacked the various scripts, and now it works on my MacBook.

However, I have just re-read the earlier comments, and indeed it is rather poor style to mix options related to CoCoA-5 into the configuration for

CoCoALib.  After all, CoCoA-5 is "just" an application which uses CoCoALib...

Moreover, fixing the scripts made me notice that the readline library depends on another library: either ncurses or termcap.  Both of these libraries

seem to be quite low-level (and both are in /usr/lib on my MacBook).

I have adapted the script readline-check-cxx.sh so that it should pick a working (built-in) "termcap library" (or give error if no such built-in library was

found).  Hopefully this will allow people to use a non-installed readline library.

Perhaps I'll ask Anna to check if everything works for her; then maybe I can try to find a way to move the script into the CoCoA-5 part...

#6 - 13 Jun 2016 20:38 - John Abbott

I have modified the readline scripts so that they accept only absolute paths as input.  Recall that there can be problems with relative paths which

begin with a minus sign (and so look like an option).  Double quotes are needed to help protect against the presence of other awkward characters.

#7 - 03 Oct 2016 14:11 - John Abbott

- Related to Design #933: Separate configure scripts for CoCoALib and CoCoA-5 added

#8 - 03 Oct 2016 14:13 - John Abbott

- Status changed from Resolved to Feedback

- % Done changed from 50 to 90

This has been "resolved" for 4 months; moving it to "feedback".  I expect the current scripts are not perfect, but they are probably sufficient for the

vast majority of cases... I hope!

#9 - 13 Oct 2016 14:25 - John Abbott

Should there also be an option to say not to use readline even if it is present?

If so, what should the option be called?  --no-readline?

It is hard to see how this might be useful for most people, but it could be handy for debugging; and I suppose it is possible that readline might be a

nuisance in some contexts?

#10 - 14 Oct 2016 13:20 - John Abbott

The options relating to readline have inconsistent names:

--with-readline=

--with-libreadline=

The new option I added is called --no-readline for the time being.

What names should we use?
#11 - 02 Mar 2017 16:12 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

#12 - 28 Apr 2017 09:13 - Anna Maria Bigatti

- Estimated time set to 4.01 h
